// Tony Urschler
// November 29, 2021

#include <limits.h>
#include <stdio.h>
#include <stdlib.h>

struct Queue {
    int front, rear, size;
    unsigned capacity;
    int *array;
};

// initializes a queue
struct Queue* createQueue(unsigned capacity)
{
    struct Queue* queue = (struct Queue*)malloc(
        sizeof(struct Queue));
    queue->capacity = capacity;
    queue->front = queue->size = 0;
    queue->rear = capacity - 1;
    queue->array = (int*)malloc(
        queue->capacity * sizeof(int));
    return queue;
}

// determines if empty
int isEmpty(struct Queue* queue)
{
    return (queue->size == 0);
}

// adds id to the end of the queue
void enqueue(struct Queue* queue, int id)
{
    queue->rear = (queue->rear + 1)
                  % queue->capacity;
    queue->array[queue->rear] = id;
    queue->size = queue->size + 1;
}

// returns INT_MIN if empty,
// else returns the next item
int dequeue(struct Queue* queue)
{
    if (isEmpty(queue))
        return INT_MIN;
    int id = queue->array[queue->front];
    queue->front = (queue->front + 1)
                   % queue->capacity;
    queue->size = queue->size - 1;
    return id;
}

// get the front of the queue
int peak(struct Queue* queue)
{
    if (isEmpty(queue))
        return INT_MIN;
    return queue->array[queue->front];
}
