// Tony Urschler
// November 25, 2021

#ifndef OSS_H
#define OSS_H

// max num of chars in msg
#define MAXSIZE 20

// struct for each of the page tables
typedef struct {
    int entry[32];
    int dirty[1];
    int present[1];
    int delimeter : 8;
} pagetable_t;

// struct for the frame table
typedef struct {
    unsigned int entry : 8;
    int owner : 5;
    int valid : 1;
    unsigned int dirty : 1;
} frametable_t;

// struct for the message queue msgs
typedef struct {
    long mtype;
    char mtext[MAXSIZE];
} msg_t;

// struct for process control block
typedef struct {
    int waitsec;
    int waitns;
    int page;
    int frame;
    int logical;
    int memaccesstime;
    unsigned char requesttype;
} pcb_t;

// methods for bit array
#define SetBit(A, k)    ( A[(k/32)] |= (1 << (k%32)) )
#define ClearBit(A, k)  ( A[(k/32)] &= ~(1 << (k%32)) )
#define TestBit(A, k)   ( A[(k/32)] & (1 << (k%32)) )

// methods for bit manip on variable
#define SetBitVar(N, k)     ( N |= (1 << k) )
#define ClearBitVar(N, k)   ( N &= ~(1 << k) )
#define TestBitVar(N, k)    ( N & (1 << k) )

#endif
