// Tony Urschler
// November 2, 2021

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/msg.h>
#include <sys/sem.h>
#include <sys/shm.h>
#include <time.h>
#include <unistd.h>
#include "config.h"
#include "oss.h"


int main(int argc, char *argv[]) {
    // setting error message
    char errmsgraw[100];
    snprintf(errmsgraw, sizeof(errmsgraw), "%s: Error", argv[0]);
    char* errmsg = errmsgraw+2;

    // getting the page table
    int segment_id;
    segment_id = atoi(argv[1]);
    pagetable_t *pagetable;
    pagetable = (pagetable_t*) shmat(segment_id, NULL, 0);

    // getting the system clock
    segment_id = atoi(argv[2]);
    int *sysclock;
    sysclock = (int*) shmat(segment_id, NULL, 0);

    // getting msg queue id
    int msgid;
    msgid = atoi(argv[3]);
    msg_t msg;

    // getting logical pid
    int lpid;
    lpid = atoi(argv[4]);

    // getting how many pages are needed
    int size;
    size = pagetable[lpid].delimeter;
    
    // seed rand()
    srand(getpid());

    // vars to check termination
    int nextcheck = (rand() % (1100 - 900)) + 900;
    int numreferences = 0;

    for (;;) {
        // determine if read or write request
        char *type = ((rand() % 100) < READ_VS_WRITE) ? "R" : "W";

        // determine the logical address wanted
        int logical = rand() % (size*1000);
        
        // determine if it should be a valid address request
        if (rand() % 1000 < 5) {
            logical = (size+1)*1000;
        }

        // sending message to parent
        msg.mtype = 22;
        snprintf(msg.mtext, 19, "%d %s %d", lpid, type, logical);
        int z = msgsnd(msgid, &msg, sizeof(msg), 0);
        if (z == -1) {
            perror(errmsg);
            exit(EXIT_FAILURE);
        }
        
        // waiting for message from parent
        msgrcv(msgid, &msg, sizeof(msg), lpid+2, 0);

        // get page from message
        int page = atoi(msg.mtext);

        // check if time to terminate
        if (numreferences >= nextcheck) {
            if (rand() % 100 < 50) {
                msg.mtype = 22;
                snprintf(msg.mtext, 19, "%d %s %d", 
                        lpid, "T", logical);
                int z = msgsnd(msgid, &msg, sizeof(msg), 0);
                if (z == -1) {
                    perror(errmsg);
                    exit(EXIT_FAILURE);
                }
                break;
            }
            else {
                nextcheck = (rand() % (1100 - 900)) + 900;
                numreferences = 0;
            }
        }
        numreferences++;
    }

    exit(EXIT_SUCCESS);
}
